﻿Type=StaticCode
Version=6.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Code module
Sub Process_Globals
End Sub

Public Sub ApproxATan2(Y As Double, X As Double) As Double
	'This function computes the theta angle faster than the ATan2 function but is very slightly less accurate
	'Note that the lgMathUtils.Atan2 function of libGDX is even faster, with the same approximation
	If X = 0 Then
		If Y > 0 Then Return cPI / 2
		If Y = 0 Then Return 0
		Return -cPI / 2
	End If
	Dim atn As Double
	Dim z As Double = Y / X
	If (z < 0 And z > -1) Or (z > 0 And z < 1) Then
		atn = z / (1 + 0.28 * z * z)
		If X < 0 Then
			If Y < 0 Then
				Return atn - cPI
			Else
				Return atn + cPI
			End If
		End If
		Return atn
	End If
	atn = cPI / 2 - z / (z * z + 0.28)
	If Y < 0 Then Return atn - cPI
	Return atn
End Sub

Public Sub FastFloor(Value As Double) As Int
	If Value < 0 Then Return Value - 1
	Return Value
End Sub

Public Sub FastRound(Value As Double) As Int
	If Value > 0 Then
		Return Value + 0.5
	Else If Value < 0 Then
		Return Value - 0.499999999
	Else
		Return Value
	End If
End Sub

Public Sub PowerInt(Base As Int, Exponent As Int) As Long
	Dim N As Long = Base
	For e = 1 To Exponent - 1
		N = N * Base
	Next
	Return N
End Sub

Public Sub PowerDbl(Base As Double, Exponent As Int) As Double
	Dim N As Double = Base
	For e = 1 To Exponent - 1
		N = N * Base
	Next
	Return N
End Sub
